require '_h2ph_pre.ph';

no warnings qw(redefine misc);

if(defined(&__MIPSEB__)) {
    if(defined(&__mips_n32) || defined(&__mips_n64)) {
	eval 'sub _MACHINE_ARCH () { &mips64eb;}' unless defined(&_MACHINE_ARCH);
	eval 'sub MACHINE_ARCH () {"mips64eb";}' unless defined(&MACHINE_ARCH);
	eval 'sub _MACHINE32_ARCH () { &mipseb;}' unless defined(&_MACHINE32_ARCH);
	eval 'sub MACHINE32_ARCH () {"mipseb";}' unless defined(&MACHINE32_ARCH);
    } else {
	eval 'sub _MACHINE_ARCH () { &mipseb;}' unless defined(&_MACHINE_ARCH);
	eval 'sub MACHINE_ARCH () {"mipseb";}' unless defined(&MACHINE_ARCH);
    }
}
 elsif(defined(&__MIPSEL__)) {
    if(defined(&__mips_n32) || defined(&__mips_n64)) {
	eval 'sub _MACHINE_ARCH () { &mips64el;}' unless defined(&_MACHINE_ARCH);
	eval 'sub MACHINE_ARCH () {"mips64el";}' unless defined(&MACHINE_ARCH);
	eval 'sub _MACHINE32_ARCH () { &mipsel;}' unless defined(&_MACHINE32_ARCH);
	eval 'sub MACHINE32_ARCH () {"mipsel";}' unless defined(&MACHINE32_ARCH);
    } else {
	eval 'sub _MACHINE_ARCH () { &mipsel;}' unless defined(&_MACHINE_ARCH);
	eval 'sub MACHINE_ARCH () {"mipsel";}' unless defined(&MACHINE_ARCH);
    }
} else {
    die("neither\ __MIPSEL__\ nor\ __MIPSEB__\ are\ defined\.");
}
unless(defined(&_KERNEL)) {
    undef(&MACHINE) if defined(&MACHINE);
    eval 'sub MACHINE () {"mips";}' unless defined(&MACHINE);
}
eval 'sub ALIGNBYTES32 () {($sizeof{\'double\'} - 1);}' unless defined(&ALIGNBYTES32);
unless(defined(&ALIGN32)) {
    sub ALIGN32 {
	my($p) = @_;
	eval q(((( &uintptr_t)($p) +  &ALIGNBYTES32) &~ &ALIGNBYTES32));
    }
}
eval 'sub SSIZE () {1;}' unless defined(&SSIZE);
eval 'sub SINCR () {1;}' unless defined(&SINCR);
if(((defined(&ENABLE_MIPS_16KB_PAGE) ? &ENABLE_MIPS_16KB_PAGE : undef) + (defined(&ENABLE_MIPS_8KB_PAGE) ? &ENABLE_MIPS_8KB_PAGE : undef) + (defined(&ENABLE_MIPS_4KB_PAGE) ? &ENABLE_MIPS_4KB_PAGE : undef)) > 1) {
    die("only\ one\ of\ ENABLE_MIPS_\{4\,8\,16\}KB_PAGE\ can\ be\ defined\.");
}
unless(defined(&MSGBUFSIZE)) {
    eval 'sub MSGBUFSIZE () { &NBPG;}' unless defined(&MSGBUFSIZE);
}
unless(defined(&COHERENCY_UNIT)) {
    eval 'sub COHERENCY_UNIT () {32;}' unless defined(&COHERENCY_UNIT);
}
if(defined(&ENABLE_MIPS_16KB_PAGE)) {
    eval 'sub PGSHIFT () {14;}' unless defined(&PGSHIFT);
}
 elsif(defined(&ENABLE_MIPS_8KB_PAGE) || (!defined(&ENABLE_MIPS_4KB_PAGE)  && (defined(&__mips) ? &__mips : undef) >= 3)) {
    eval 'sub PGSHIFT () {13;}' unless defined(&PGSHIFT);
} else {
    eval 'sub PGSHIFT () {12;}' unless defined(&PGSHIFT);
}
eval 'sub NBPG () {(1<<  &PGSHIFT);}' unless defined(&NBPG);
eval 'sub PGOFSET () {( &NBPG - 1);}' unless defined(&PGOFSET);
eval 'sub PTPSHIFT () {2;}' unless defined(&PTPSHIFT);
eval 'sub PTPLENGTH () {( &PGSHIFT -  &PTPSHIFT);}' unless defined(&PTPLENGTH);
eval 'sub NPTEPG () {(1<<  &PTPLENGTH);}' unless defined(&NPTEPG);
eval 'sub SEGSHIFT () {( &PGSHIFT +  &PTPLENGTH);}' unless defined(&SEGSHIFT);
eval 'sub NBSEG () {(1<<  &SEGSHIFT);}' unless defined(&NBSEG);
eval 'sub SEGOFSET () {( &NBSEG-1);}' unless defined(&SEGOFSET);
if(defined(&_LP64)) {
    eval 'sub SEGLENGTH () {( &PGSHIFT - 3);}' unless defined(&SEGLENGTH);
    eval 'sub XSEGSHIFT () {( &SEGSHIFT +  &SEGLENGTH);}' unless defined(&XSEGSHIFT);
    eval 'sub NBXSEG () {(1 <<  &XSEGSHIFT);}' unless defined(&NBXSEG);
    eval 'sub XSEGOFSET () {( &NBXSEG - 1);}' unless defined(&XSEGOFSET);
    eval 'sub XSEGLENGTH () {( &PGSHIFT - 3);}' unless defined(&XSEGLENGTH);
    eval 'sub NXSEGPG () {(1<<  &XSEGLENGTH);}' unless defined(&NXSEGPG);
} else {
    eval 'sub SEGLENGTH () {(31-  &SEGSHIFT);}' unless defined(&SEGLENGTH);
}
eval 'sub NSEGPG () {(1<<  &SEGLENGTH);}' unless defined(&NSEGPG);
if((defined(&PGSHIFT) ? &PGSHIFT : undef) >= 13) {
    eval 'sub UPAGES () {1;}' unless defined(&UPAGES);
} else {
    eval 'sub UPAGES () {2;}' unless defined(&UPAGES);
}
eval 'sub USPACE () {( &UPAGES* &NBPG);}' unless defined(&USPACE);
eval 'sub USPACE_ALIGN () { &USPACE;}' unless defined(&USPACE_ALIGN);
eval 'sub NKMEMPAGES_MIN_DEFAULT () {((8* 1024* 1024) >>  &PAGE_SHIFT);}' unless defined(&NKMEMPAGES_MIN_DEFAULT);
eval 'sub NKMEMPAGES_MAX_DEFAULT () {((128* 1024* 1024) >>  &PAGE_SHIFT);}' unless defined(&NKMEMPAGES_MAX_DEFAULT);
unless(defined(&mips_round_page)) {
    sub mips_round_page {
	my($x) = @_;
	eval q((((( &uintptr_t)($x)) +  &NBPG - 1) & ~( &NBPG-1)));
    }
}
unless(defined(&mips_trunc_page)) {
    sub mips_trunc_page {
	my($x) = @_;
	eval q((( &uintptr_t)($x) & ~( &NBPG-1)));
    }
}
unless(defined(&mips_btop)) {
    sub mips_btop {
	my($x) = @_;
	eval q((( &paddr_t)($x) >>  &PGSHIFT));
    }
}
unless(defined(&mips_ptob)) {
    sub mips_ptob {
	my($x) = @_;
	eval q((( &paddr_t)($x) <<  &PGSHIFT));
    }
}
if(defined(&__MIPSEL__)) {
    eval 'sub MID_MACHINE () { &MID_PMAX;}' unless defined(&MID_MACHINE);
}
if(defined(&__MIPSEB__)) {
    eval 'sub MID_MACHINE () { &MID_MIPS;}' unless defined(&MID_MACHINE);
}
unless(defined(&MSIZE)) {
    if(defined(&_LP64)) {
	eval 'sub MSIZE () {512;}' unless defined(&MSIZE);
    } else {
	eval 'sub MSIZE () {256;}' unless defined(&MSIZE);
    }
    unless(defined(&MCLSHIFT)) {
	eval 'sub MCLSHIFT () {11;}' unless defined(&MCLSHIFT);
    }
    eval 'sub MCLBYTES () {(1<<  &MCLSHIFT);}' unless defined(&MCLBYTES);
}
1;
